*---------------------------------------------------------------------------------------------
*
* gcc example2.s
* hex display board functional test
*
* 04/05/2023 steve crompton
*
*---------------------------------------------------------------------------------------------

    .global _start

    .text

    .equ hex_display,0xAB0000

    dc.w 0x601A                     /* integer 601AH denotes text, data, and bss are contiguous */
    dc.l _end-_start                /* number of bytes in text segment */
    dc.l 0x00000000                 /* number of bytes in data segment */
    dc.l 0x00000000                 /* number of bytes in bss */
    dc.l 0x00000000                 /* number of bytes in symbol table */
    dc.l 0x00000000                 /* reserved; always zero */
    dc.l _start                     /* beginning of text segment and of program execution */
    dc.w 0xFFFF                     /* integer flag for relocation bits; */
                                    /* if 0, relocation bits exist; */
                                    /* if not 0, no relocation bits exist */

_start:

    move.l #0,%d0                   /* zero the counter */
    move.l #1,%d1                   /* set the counter step value */
    move.l #16,%d2                  /* set the switch digit count */

loop:

    move.l %d0,hex_display          /* display current count on the hex display */

    cmp.l %d0,%d2                   /* switch digit point reached? */
    bne.s no_switch

* switch digit

    asl.l #4,%d1                    /* 16x the counter step value */
    asl.l #4,%d2                    /* 16x the switch digit count */

no_switch:

    add.l %d1,%d0                   /* step the counter on */

    cmp.l #0,%d1                    /* all 8 digits done? */
    beq.s forever

* wait

    move.l #0x60000,%d3             /* set wait time */

delay:

    sub.l #1,%d3                    /* wait */
    bne.s delay

* wait end

    bra.s loop                      /* repeat */

forever:

*   bra.s forever                   /* wait for reset button to be pressed */

    rts                             /* return to cp/m-68k */

_end:

    .end

*---------------------------------------------------------------------------------------------
